<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::static_map_kernel_1&lt; domain, range, compare &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classdlib_1_1static__map__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::static_map_kernel_1&lt; domain, range, compare &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::static_map_kernel_1&lt; domain, range, compare &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1static__map__kernel__1.png" usemap="#dlib::static_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20compare_20_3E_map" alt=""/>
  <map id="dlib::static_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20compare_20_3E_map" name="dlib::static_5Fmap_5Fkernel_5F1_3C_20domain_2C_20range_2C_20compare_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;" shape="rect" coords="0,0,317,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1_1_1mpair.html">mpair</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a58886536172f63ef1a685a2023fa42a4"><td class="memItemLeft" align="right" valign="top"><a id="a58886536172f63ef1a685a2023fa42a4"></a>
typedef domain&#160;</td><td class="memItemRight" valign="bottom"><b>domain_type</b></td></tr>
<tr class="separator:a58886536172f63ef1a685a2023fa42a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7675a3ddff262ba3e4297da92bc6fb73"><td class="memItemLeft" align="right" valign="top"><a id="a7675a3ddff262ba3e4297da92bc6fb73"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a7675a3ddff262ba3e4297da92bc6fb73"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf4f95ba9e7b71fb356446244521ebe5"><td class="memItemLeft" align="right" valign="top"><a id="acf4f95ba9e7b71fb356446244521ebe5"></a>
typedef compare&#160;</td><td class="memItemRight" valign="bottom"><b>compare_type</b></td></tr>
<tr class="separator:acf4f95ba9e7b71fb356446244521ebe5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a82cfe85dfcb5be3ae550ca208eb665cb"><td class="memItemLeft" align="right" valign="top"><a id="a82cfe85dfcb5be3ae550ca208eb665cb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a82cfe85dfcb5be3ae550ca208eb665cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3af3d267879f6d6ee87156d2c0a9490"><td class="memItemLeft" align="right" valign="top"><a id="ac3af3d267879f6d6ee87156d2c0a9490"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>load</b> (<a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a>&lt; domain, range &gt; &amp;source)</td></tr>
<tr class="separator:ac3af3d267879f6d6ee87156d2c0a9490"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a934ae52f6a79ce0d1f2d399bb0fefcd3"><td class="memItemLeft" align="right" valign="top"><a id="a934ae52f6a79ce0d1f2d399bb0fefcd3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>load</b> (<a class="el" href="classdlib_1_1asc__pair__remover.html">asc_pair_remover</a>&lt; domain, range, compare &gt; &amp;source)</td></tr>
<tr class="separator:a934ae52f6a79ce0d1f2d399bb0fefcd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a876e349a20a71dc61019d160b7426265"><td class="memItemLeft" align="right" valign="top"><a id="a876e349a20a71dc61019d160b7426265"></a>
const range *&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;d) const</td></tr>
<tr class="separator:a876e349a20a71dc61019d160b7426265"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ff7e883bd80bcb56f0b3838f7af4ebd"><td class="memItemLeft" align="right" valign="top"><a id="a6ff7e883bd80bcb56f0b3838f7af4ebd"></a>
range *&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;d)</td></tr>
<tr class="separator:a6ff7e883bd80bcb56f0b3838f7af4ebd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ef75d5be6fc3b86fef908de22691ac9"><td class="memItemLeft" align="right" valign="top"><a id="a5ef75d5be6fc3b86fef908de22691ac9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a5ef75d5be6fc3b86fef908de22691ac9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91455aca10ea9ead103b98bc1502688a"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a91455aca10ea9ead103b98bc1502688a">size</a> () const</td></tr>
<tr class="separator:a91455aca10ea9ead103b98bc1502688a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5aa12f80986467d868277145a5f795ad"><td class="memItemLeft" align="right" valign="top"><a id="a5aa12f80986467d868277145a5f795ad"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a5aa12f80986467d868277145a5f795ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee4ceab9ae3f7d8f184328543a132aaa"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#aee4ceab9ae3f7d8f184328543a132aaa">reset</a> () const</td></tr>
<tr class="separator:aee4ceab9ae3f7d8f184328543a132aaa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae53a7e137fba03373f6abcbb775c1641"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#ae53a7e137fba03373f6abcbb775c1641">current_element_valid</a> () const</td></tr>
<tr class="separator:ae53a7e137fba03373f6abcbb775c1641"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0eb68f6a1f002de02008d2cb7e6627a5"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a0eb68f6a1f002de02008d2cb7e6627a5">element</a> () const</td></tr>
<tr class="separator:a0eb68f6a1f002de02008d2cb7e6627a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab83f843390ea48c1e958f914b50122e3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#ab83f843390ea48c1e958f914b50122e3">element</a> ()</td></tr>
<tr class="separator:ab83f843390ea48c1e958f914b50122e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd85a3044ae4f943eadca62c2c7ea6e3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#abd85a3044ae4f943eadca62c2c7ea6e3">move_next</a> () const</td></tr>
<tr class="separator:abd85a3044ae4f943eadca62c2c7ea6e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a924ccbd91fb9e935ec1dd59d929a5ade"><td class="memItemLeft" align="right" valign="top"><a id="a924ccbd91fb9e935ec1dd59d929a5ade"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>binary_search</b> (const domain &amp;item, unsigned long &amp;pos) const</td></tr>
<tr class="separator:a924ccbd91fb9e935ec1dd59d929a5ade"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a001f56ba5f6768398081d5c2c636f4e5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a001f56ba5f6768398081d5c2c636f4e5">sort_arrays</a> (unsigned long left, unsigned long right)</td></tr>
<tr class="separator:a001f56ba5f6768398081d5c2c636f4e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c6b209c74f374384b503ca15dffafaa"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a4c6b209c74f374384b503ca15dffafaa">qsort_partition</a> (unsigned long &amp;partition_element, const unsigned long left, const unsigned long right)</td></tr>
<tr class="separator:a4c6b209c74f374384b503ca15dffafaa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34295360a065f601239777570961a7f2"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a34295360a065f601239777570961a7f2">median</a> (unsigned long one, unsigned long two, unsigned long three)</td></tr>
<tr class="separator:a34295360a065f601239777570961a7f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d0d605e58f1abd289ca8c1284747dd1"><td class="memItemLeft" align="right" valign="top"><a id="a8d0d605e58f1abd289ca8c1284747dd1"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>static_map_kernel_1</b> (<a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a8d0d605e58f1abd289ca8c1284747dd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f223586ec2f9ad44a2e1820767d9910"><td class="memItemLeft" align="right" valign="top"><a id="a1f223586ec2f9ad44a2e1820767d9910"></a>
<a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a1f223586ec2f9ad44a2e1820767d9910"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a342222c87e900f99550ec3086e6a8d3d"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1static__map__kernel__1.html#a342222c87e900f99550ec3086e6a8d3d">map_size</a></td></tr>
<tr class="separator:a342222c87e900f99550ec3086e6a8d3d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a010583d262b40036661f5b1db0a36ca9"><td class="memItemLeft" align="right" valign="top"><a id="a010583d262b40036661f5b1db0a36ca9"></a>
domain *&#160;</td><td class="memItemRight" valign="bottom"><b>d</b></td></tr>
<tr class="separator:a010583d262b40036661f5b1db0a36ca9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f5ffcca83be916450b7e23aef8c7ef3"><td class="memItemLeft" align="right" valign="top"><a id="a6f5ffcca83be916450b7e23aef8c7ef3"></a>
range *&#160;</td><td class="memItemRight" valign="bottom"><b>r</b></td></tr>
<tr class="separator:a6f5ffcca83be916450b7e23aef8c7ef3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad396c81d9e73f50d134424263f650710"><td class="memItemLeft" align="right" valign="top"><a id="ad396c81d9e73f50d134424263f650710"></a>
<a class="el" href="classdlib_1_1static__map__kernel__1_1_1mpair.html">mpair</a>&#160;</td><td class="memItemRight" valign="bottom"><b>mp</b></td></tr>
<tr class="separator:ad396c81d9e73f50d134424263f650710"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03003fdd2190a6d639711d92d96834f0"><td class="memItemLeft" align="right" valign="top"><a id="a03003fdd2190a6d639711d92d96834f0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start_</b></td></tr>
<tr class="separator:a03003fdd2190a6d639711d92d96834f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeca82c8034ee2c5bf4a35e2a910d89e6"><td class="memItemLeft" align="right" valign="top"><a id="aeca82c8034ee2c5bf4a35e2a910d89e6"></a>
compare&#160;</td><td class="memItemRight" valign="bottom"><b>comp</b></td></tr>
<tr class="separator:aeca82c8034ee2c5bf4a35e2a910d89e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a93f0d0ee203768c67898c30e3dcd7feb"><td class="memItemLeft" align="right" valign="top"><a id="a93f0d0ee203768c67898c30e3dcd7feb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>deserialize</b> (<a class="el" href="classdlib_1_1static__map__kernel__1.html">static_map_kernel_1</a> &amp;item, std::istream &amp;in)</td></tr>
<tr class="separator:a93f0d0ee203768c67898c30e3dcd7feb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae53a7e137fba03373f6abcbb775c1641"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae53a7e137fba03373f6abcbb775c1641">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="ab83f843390ea48c1e958f914b50122e3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab83f843390ea48c1e958f914b50122e3">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a0eb68f6a1f002de02008d2cb7e6627a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0eb68f6a1f002de02008d2cb7e6627a5">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a34295360a065f601239777570961a7f2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a34295360a065f601239777570961a7f2">&#9670;&nbsp;</a></span>median()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::median </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>one</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>two</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>three</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires                   
    - left &lt; right
    - left and right are within the bounts of the array
ensures
    - the convention is still true
    - left &lt;= #partition_element &lt;= right                              
    - all elements in #d &lt; #d[#partition_element] have 
      indices &gt;= left and &lt; #partition_element                         
    - all elements in #d &gt;= #d[#partition_element] have 
      indices &gt;= #partition_element and &lt;= right
</pre><p> ! </p>

</div>
</div>
<a id="abd85a3044ae4f943eadca62c2c7ea6e3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd85a3044ae4f943eadca62c2c7ea6e3">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a4c6b209c74f374384b503ca15dffafaa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c6b209c74f374384b503ca15dffafaa">&#9670;&nbsp;</a></span>qsort_partition()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::qsort_partition </td>
          <td>(</td>
          <td class="paramtype">unsigned long &amp;&#160;</td>
          <td class="paramname"><em>partition_element</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned long&#160;</td>
          <td class="paramname"><em>left</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned long&#160;</td>
          <td class="paramname"><em>right</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires    
    - left and right are within the bounts of the array
ensures 
    - everything in the convention is still true and d[left] though
      d[right] is sorted according to operator&lt;
</pre><p> ! </p>

</div>
</div>
<a id="aee4ceab9ae3f7d8f184328543a132aaa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aee4ceab9ae3f7d8f184328543a132aaa">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a91455aca10ea9ead103b98bc1502688a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a91455aca10ea9ead103b98bc1502688a">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a001f56ba5f6768398081d5c2c636f4e5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a001f56ba5f6768398081d5c2c636f4e5">&#9670;&nbsp;</a></span>sort_arrays()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::sort_arrays </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>left</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>right</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (there is an item in d equivalent to item) then
        - returns true
        - d[#pos] is equivalent item
    - else
        - returns false
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a342222c87e900f99550ec3086e6a8d3d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a342222c87e900f99550ec3086e6a8d3d">&#9670;&nbsp;</a></span>map_size</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain, typename range, typename compare = std::less&lt;domain&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1static__map__kernel__1.html">dlib::static_map_kernel_1</a>&lt; domain, range, compare &gt;::map_size</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - one, two, and three are valid indexes into d
ensures
    - returns the median of d[one], d[two], and d[three]
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="static__map__kernel__1_8h_source.html">static_map_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
